//
//  SynthEcho.m
//
//  Created by 成田 拓郎 on 10/05/30.
//  Copyright 2010 lovelyshark. All rights reserved.
//

#import "SynthEcho.h"


@implementation SynthEcho

@synthesize delayTime;
@synthesize delayLevel;

//このオブジェクトの演算関数
- (void) synthFunc:(int)length
{
	int delay_step = delayTime * [SynthObject outputSampleRate:-1.0f];
	if (delay_step <= 0)
		delay_step = 1;
	else if (delay_step > SAMPLE_RATE)
		delay_step = SAMPLE_RATE;

	//出力バッファの準備
	float *waveout_src  = (inputWaveObject) ? inputWaveObject.outputBuffer : [SynthObject dummyBuffer0];
	float *waveout_src1 = waveout_src;
	float *waveout_src2 = delayBuffer + SAMPLE_RATE - delay_step;
	float *waveout_dest = outputBuffer;
	float *waveout_end1 = waveout_dest + ((delay_step < length) ? delay_step : length);
	float *waveout_end2 = waveout_dest + length;
	
	//２つの入力を加算して出力
	while (waveout_dest != waveout_end1) {
		(*waveout_dest) = (*waveout_src1)  + (*waveout_src2) * delayLevel;
		++waveout_src1;
		++waveout_src2;
		++waveout_dest;
	}
	waveout_src2 = waveout_src;
	while (waveout_dest != waveout_end2) {
		(*waveout_dest) = (*waveout_src1)  + (*waveout_src2) * delayLevel;
		++waveout_src1;
		++waveout_src2;
		++waveout_dest;
	}

	//次回ディレイ用処理
	waveout_src1 = delayBuffer + length;
	waveout_src2 = waveout_src;
	waveout_dest = delayBuffer;
	waveout_end1 = waveout_dest + SAMPLE_RATE - length;
	waveout_end2 = waveout_dest + SAMPLE_RATE;
	while (waveout_dest != waveout_end1) {
		*waveout_dest = *waveout_src1;
		++waveout_dest;
		++waveout_src1;
	}
	while (waveout_dest != waveout_end2) {
		*waveout_dest = *waveout_src2;
		++waveout_dest;
		++waveout_src2;
	}
}

- (id) init
{
	if (self = [super init])
	{
		// バッファ初期化
		float *dest = delayBuffer;
		float *dest_end = dest + SAMPLE_RATE;
		while (dest != dest_end) {
			*dest = 0.0f;
			++dest;
		}
		delayTime  = 0.1f;
		delayLevel = 0.0f;
	}
	
	return self;
}

@end
