//
//  SynthesizerOutput.h
//  AnalogSynthesizer
//
//  Created by 成田 拓郎 on 10/05/28.
//  Copyright 2010 lovelyshark. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "AudioOutput.h"
#import "SynthVCO.h"
#import "SynthVCF.h"
#import "SynthVCA.h"
#import "SynthEG.h"
#import "SynthMix.h"
#import "SynthEcho.h"

#define SYNTH_NUM	4	//VCO-VCF-VCAセットの数

@interface SynthesizerOutput : AudioOutput {
	// キーボード
	UInt32 keyboard;

	//シンセサイザ
	UInt32 noteNumber[SYNTH_NUM]; //出力中のノート番号
	SynthVCO *synthVCO[SYNTH_NUM];
	SynthVCF *synthVCF[SYNTH_NUM];
	SynthVCA *synthVCA[SYNTH_NUM];
	SynthEG  *synthEG[SYNTH_NUM];

	SynthVCO *synthLFO; //LFOは共通
	SynthMix *synthMix;
	SynthEcho *synthEcho;
}

@property UInt32 keyboard;

@property int   vcoWaveType;
@property float vcoPulseWidth;
@property float vcoControlLevel;

@property float vcfCutOffFrequency;
@property float vcfResonance;
@property float vcfControlLevel;

@property float vcaControlLevel;

@property float egParamAttack;
@property float egParamDecay;
@property float egParamSustain;
@property float egParamRelease;

@property int   lfoWaveType;
@property float lfoPulseWidth;
@property float lfoFrequency;

@property float echoDelayTime;
@property float echoDelayLevel;

@end
